## genomicsdb 1.4.4

=== CMakeLists.txt ===
#
# CMakeLists.txt
#
# The MIT License
#
# Copyright (c) 2019-2022 Omics Data Automation, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

project(GenomicsDB)
cmake_minimum_required(VERSION 3.17)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/Modules")

if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
  message(FATAL_ERROR CMAKE_CXX_COMPILER_ID " Compiler not yet supported. Exiting.")
endif()

#External dependencies. Can be overridden to point to custom locations
set(HTSLIB_SOURCE_DIR "${CMAKE_SOURCE_DIR}/dependencies/htslib" CACHE PATH "Path to htslib source directory")
set(TILEDB_SOURCE_DIR "${CMAKE_SOURCE_DIR}/dependencies/TileDB" CACHE PATH "Path to TileDB source directory")
set(RAPIDJSON_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/dependencies/RapidJSON/include" CACHE PATH "Path to RapidJSON include directory")
set(SPDLOG_INCLUDE_DIR  "${CMAKE_SOURCE_DIR}/dependencies/spdlog/include" CACHE PATH "Path to SpdLog include directory")
#The fmt headers are in dependencies/spdlog/include/spdlog/fmt/bundled - source files will include "fmt/bundled/format.h"
set(FMT_ROOT_DIR "${SPDLOG_INCLUDE_DIR}" CACHE PATH "Path to fmt library")
set(USING_FMT_BUNDLED_WITH_SPDLOG True CACHE BOOL "Disable if using fmt library that's not bundled with spdlog")

#GIT_COMMIT_HASH derived from git tag to be used as part of GENOMICSDB_VERSION
execute_process(
    COMMAND git log -1 --format=%h
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )

#Build parameters/options
set(GENOMICSDB_RELEASE_VERSION "1.4.4-SNAPSHOT" CACHE STRING "GenomicsDB release version") #used in Maven builds
set(GENOMICSDB_VERSION "${GENOMICSDB_RELEASE_VERSION}-${GIT_COMMIT_HASH}" CACHE STRING "GenomicsDB full version string")

option(BUILD_DISTRIBUTABLE_LIBRARY "Build the GenomicsDB library with minimal runtime dependencies")
option(BUILD_FOR_PYTHON "Build GenomicsDB library with minimal runtime, no jvm/openssl/curl dependencies and python protobuf bindings")
option(BUILD_JAVA "Build Java/JNI interface for combined VCF records")

option(DISABLE_MPI "Disable use of any MPI compiler/libraries")
option(DISABLE_OPENMP "Disable OpenMP")

set(HTSLIB_INSTALL_DIR "" CACHE PATH "Path to htslib install directory")

#Sync the GENOMICSDB_PROTOBUF_VERSION with protobuf.version in pom.xml!
set(GENOMICSDB_PROTOBUF_VERSION "3.19.4" CACHE STRING "Version of Google Protocol Buffer library")
set(PROTOBUF_ROOT_DIR "$ENV{HOME}/protobuf-install/${GENOMICSDB_PROTOBUF_VERSION}" CACHE PATH "Path to installed protobuf")
set(PROTOBUF_URL "https://github.com/protocolbuffers/protobuf/archive/v${GENOMICSDB_PROTOBUF_VERSION}.zip" CACHE STRING "URL to protobuf github release")
set(PROTOBUF_REGENERATE True CACHE BOOL "Regenerate protocol buffers C++ files")
set(GENERATE_PROTOBUF_FILES_IN_BUILD_DIR True CACHE BOOL "Generate all protobuf files in build directory")

set(USE_LIBCSV False CACHE BOOL "Disable library components that import data from csv files")
set(LIBCSV_DIR "" CACHE PATH "Path to libcsv header and library")

#Profiling
option(DO_PROFILING "Collect some stats during execution - doesn't add much overhead")
option(COUNT_NUM_CELLS_BETWEEN_TWO_CELLS_FROM_THE_SAME_ROW "Counting #cells traversed in columnar iterator")
option(PROFILE_NUM_CELLS_TO_TRAVERSE_AT_EVERY_QUERY_INTERVAL "Counting #cells traversed in columnar iterator in sliding window")
option(DO_MEMORY_PROFILING "Collect memory consumption in parts of the combine gVCF program - high overhead")

#See https://gperftools.github.io/gperftools/cpuprofile.html
option(USE_GPERFTOOLS "Collect profiling information using gperftools/profiler for analysis with pprof")
#See https://gperftools.github.io/gperftools/heapprofile.html
option(USE_GPERFTOOLS_HEAP "Collect heap profiling information using gperftools/tcmalloc for analysis with pprof")

set(GENOMICSDB_MAVEN_BUILD_DIR ${CMAKE_BINARY_DIR}/target CACHE PATH "Path to maven build directory")
set(MAVEN_QUIET False CACHE BOOL "Do not print mvn messages")
set(GENOMICSDB_MAVEN_PROFILE "" CACHE STRING "Profile to compile with Spark 2 or Java 11") # used in Maven builds
set(GPG_PASSPHRASE "" CACHE STRING "Gpg passphrase for deploying to maven")

set(IPPROOT "" CACHE PATH "Path to IPP libraries - used when intel optimized zlib is required")

set(LIBDBI_DIR "" CACHE PATH "Path to libdbi install directory")

# if no build build type is specified, default to release builds
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "GenomicsDB default set to Release" FORCE)
endif()
message(STATUS "CMAKE_BUILD_TYPE=" ${CMAKE_BUILD_TYPE})

set(USE_HDFS True CACHE BOOL "Enables HDFS support")
set(BUILD_FOR_ARCH "" CACHE STRING "Arch for which to build - values passed to -march= option for gcc")

#See https://cmake.org/Wiki/CMake_RPATH_handling#Common_questions
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH True)
if(APPLE)
  set(CMAKE_MACOSX_RPATH True CACHE BOOL "Set rpath on OSX")
  set(CMAKE_FIND_FRAMEWORK LAST CACHE STRING "Try to find frameworks on Mac OS X last")
endif()

enable_testing()

#Platform check modules
include(CheckIncludeFileCXX)
include(CheckCXXSymbolExists)
   
#Optimization flag
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND BUILD_FOR_ARCH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${BUILD_FOR_ARCH}")
endif()

if(BUILD_DISTRIBUTABLE_LIBRARY OR BUILD_FOR_PYTHON)
    set(DISABLE_MPI True)
    set(DISABLE_OPENMP True)
    if(APPLE)
        set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13")
    endif()
endif()
if (BUILD_DISTRIBUTABLE_LIBRARY AND NOT BUILD_FOR_PYTHON)
    #For the GNU compiler, link in static gcc libraries
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libgcc -static-libstdc++")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++")
    endif()
endif()

#Check C++ 2011 support
include(CheckAndSetStdCXX2011Flag)
CHECK_AND_SET_STD_CXX_2011_FLAG(test_cpp_2011)
if(NOT test_cpp_2011)
    message(FATAL_ERROR "Your compiler does not support C++ 2011, exiting")
endif()
#Check for stack-protector-strong
include(CheckAndSetStackProtectorStrong)
CHECK_AND_SET_STACK_PROTECTOR_STRONG_FLAG(test_stack_protector_strong)
if(NOT test_stack_protector_strong)
    message(STATUS "Using -fstack-protector instead of -fstack-protector-strong")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector")
endif()

#Compiler Warning Options
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-reorder -Wno-unknown-pragmas -Wno-unused-variable -Wno-unused-but-set-variable -Wno-unused-result")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z noexecstack -z relro -z now")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-reorder -Wno-unused-variable -Wno-pessimizing-move -Wno-deprecated-declarations")
endif()

#MPI library/compiler etc
if(NOT DISABLE_MPI)
    find_package(MPI REQUIRED)
    include_directories(${MPI_CXX_INCLUDE_PATH})
else()
    add_definitions(-DDISABLE_MPI=1)
endif()

if(NOT DISABLE_OPENMP)
    find_package(OpenMPv4)
    if(NOT OPENMPV4_FOUND)
        set(DISABLE_OPENMP True)
    else()
        set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    endif()
endif()
if(DISABLE_OPENMP)
    add_definitions(-DDISABLE_OPENMP=1)
endif()

add_definitions(-D_FILE_OFFSET_BITS=64)  #large file support
add_definitions(-DDUPLICATE_CELL_AT_END=1) #mandatory
add_definitions(-DGENOMICSDB_VERSION=\"${GENOMICSDB_VERSION}\")

if(CMAKE_BUILD_TYPE STREQUAL "Release")
  add_definitions(-D_FORTIFY_SOURCE=2)
endif()

find_package(StringView)
if(NOT STRING_VIEW_FOUND AND NOT STRING_VIEW_EXPERIMENTAL_FOUND)
  message(FATAL_ERROR "No string_view found. Use a compiler that supports std::string_view for now")
endif()

find_package(libuuid REQUIRED)
include_directories(${LIBUUID_INCLUDE_DIR})

#OpenSSL required by TileDB and CURL
if(BUILD_DISTRIBUTABLE_LIBRARY)
  set(OPENSSL_USE_STATIC_LIBS TRUE)
endif()
find_package(OpenSSL REQUIRED)
find_package(CURL REQUIRED)

#RapidJSON
find_package(RapidJSON REQUIRED)
include_directories(${RAPIDJSON_INCLUDE_DIR})

#SpdLog
find_package(Spdlog REQUIRED)
include_directories(${SPDLOG_INCLUDE_DIR})

#htslib
find_package(htslib REQUIRED)
include_directories(BEFORE ${HTSLIB_INCLUDE_DIR})

#TileDB
find_package(TileDB REQUIRED)
include_directories(${TILEDB_INCLUDE_DIR})
#include_directories(${TILEDB_INCLUDE_DIR})

#librt
find_library(LIBRT_LIBRARY rt)

#fmt library
find_package(fmt REQUIRED)
include_directories(${FMT_INCLUDE_DIR})
if(USING_FMT_BUNDLED_WITH_SPDLOG)
  add_definitions(-DUSING_FMT_BUNDLED_WITH_SPDLOG)
endif()

#pgsql driver and dbi libs
#find_package(libdbi)
#if(LIBDBI_FOUND)
    #include_directories(${LIBDBI_INCLUDE_DIR})
    #add_definitions(-DLIBDBI)
#endif()

#Protobuf library
find_package(ProtobufWrapper REQUIRED)
if(GENERATE_PROTOBUF_FILES_IN_BUILD_DIR)
  set(PROTOBUF_JAVA_OUTPUT_DIR "${CMAKE_BINARY_DIR}/src/main/java")
else()
  set(PROTOBUF_JAVA_OUTPUT_DIR "${CMAKE_SOURCE_DIR}/src/main/java")
endif()
include_directories(${PROTOBUF_INCLUDE_DIRS})

#JNI
if(BUILD_JAVA)
    if(CMAKE_CROSSCOMPILING)
	set(JAVA_HOME ${TARGET_JAVA_HOME})
	set(ENV{JAVA_HOME} ${TARGET_JAVA_HOME})
    endif()
    find_package(JNI REQUIRED)
    if(CMAKE_CROSSCOMPILING)
	unset(JAVA_HOME)
	unset(ENV{JAVA_HOME})
    endif()
    find_package(Java 1.8 REQUIRED)
    include_directories(${JNI_INCLUDE_DIRS})
    include_directories(src/main/jni/include)
    include(UseJava)
endif()

#libcsv
if(NOT BUILD_DISTRIBUTABLE_LIBRARY AND NOT BUILD_FOR_PYTHON)
    if(USE_LIBCSV)
        find_package(libcsv REQUIRED)
    else()
        find_package(libcsv)
    endif()
endif()
if(LIBCSV_FOUND)
    include_directories(${LIBCSV_INCLUDE_DIR})
    set(USE_LIBCSV True)
    add_definitions(-DUSE_LIBCSV)
endif()

#Collect stats
if(DO_PROFILING)
    message(STATUS "Enabling stats collection")
    add_definitions(-DDO_PROFILING=1)
    #Collect some more stats
    if(COUNT_NUM_CELLS_BETWEEN_TWO_CELLS_FROM_THE_SAME_ROW)
        message(STATUS "Enabling COUNT_NUM_CELLS_BETWEEN_TWO_CELLS_FROM_THE_SAME_ROW")
        add_definitions(-DCOUNT_NUM_CELLS_BETWEEN_TWO_CELLS_FROM_THE_SAME_ROW=1)
    endif()
    if(PROFILE_NUM_CELLS_TO_TRAVERSE_AT_EVERY_QUERY_INTERVAL)
        message(STATUS "Enabling PROFILE_NUM_CELLS_TO_TRAVERSE_AT_EVERY_QUERY_INTERVAL")
        add_definitions(-DPROFILE_NUM_CELLS_TO_TRAVERSE_AT_EVERY_QUERY_INTERVAL=1)
    endif()
endif()

#Collect stats to use with gperf/pprof
#See https://gperftools.github.io/gperftools/cpuprofile.html
#See https://gperftools.github.io/gperftools/heapprofile.html
if(USE_GPERFTOOLS OR USE_GPERFTOOLS_HEAP)

=== core/CMakeLists.txt ===
#
# core/CMakeLists.txt
#
#
# The MIT License
#
# Copyright (c) 2016 MIT and Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

# Include core header directories
file(GLOB TILEDB_CORE_INCLUDE_DIRS "include/*" 
	"src/codec/external/lz4"
	"src/codec/external/bitshuffle")
include_directories(${TILEDB_CORE_INCLUDE_DIRS})

# Gather the core source files
file(GLOB_RECURSE TILEDB_CORE_SOURCES "src/*.cc" "src/codec/external/bitshuffle/*.c")
if(LZ4_FOUND)
    Message(STATUS "Using LZ4 from ${LZ4_LIBRARIES}")
else()
    list(APPEND TILEDB_CORE_SOURCES "src/codec/external/lz4/lz4.c")
endif()

# Compile sources with PIC
add_library(TILEDB_CORE_OBJECTS OBJECT ${TILEDB_CORE_SOURCES})
set_property(TARGET TILEDB_CORE_OBJECTS PROPERTY POSITION_INDEPENDENT_CODE ON)

add_dependencies(TILEDB_CORE_OBJECTS awssdk-ep)
add_dependencies(TILEDB_CORE_OBJECTS gcssdk-ep)

# Create static and shared libraries
if(USE_HDFS)
    add_library(tiledb_static STATIC $<TARGET_OBJECTS:TILEDB_CORE_OBJECTS> $<TARGET_OBJECTS:hdfs_OBJECTS>)
    add_library(tiledb_shared SHARED $<TARGET_OBJECTS:TILEDB_CORE_OBJECTS> $<TARGET_OBJECTS:hdfs_OBJECTS>)
else()
    add_library(tiledb_static STATIC $<TARGET_OBJECTS:TILEDB_CORE_OBJECTS>)
    add_library(tiledb_shared SHARED $<TARGET_OBJECTS:TILEDB_CORE_OBJECTS>)
endif()

set_target_properties(tiledb_static PROPERTIES OUTPUT_NAME "tiledb")
set_target_properties(tiledb_shared PROPERTIES OUTPUT_NAME "tiledb")

target_link_libraries(tiledb_static muparserx azure-storage-lite ${AWSSDK_LINK_LIBRARIES} ${GCSSDK_LINK_LIBRARIES})
target_link_libraries(tiledb_shared ${TILEDB_LIB_DEPENDENCIES})

# Install libraries
install(
    TARGETS tiledb_static tiledb_shared 
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
)
file(GLOB TILEDB_HEADERS "include/c_api/*.h")
install(FILES ${TILEDB_HEADERS} DESTINATION include)

=== examples/CMakeLists.txt ===
#
# examples/CMakeLists.txt
#
#
# The MIT License
#
# Copyright (c) 2016 MIT and Intel Corporation
# Copyright (c) 2018-2019 Omics Data Automation, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

# Function that builds an executable per example
function(build_TileDB_example TARGET)
  add_executable(${TARGET} EXCLUDE_FROM_ALL src/${TARGET}.cc)
  target_link_libraries(${TARGET} tiledb_static ${TILEDB_LIB_DEPENDENCIES})
endfunction()

# Get the example sources
file(GLOB TILEDB_EXAMPLE_SOURCES "src/*.cc")

# Include TileDB C API headers
include_directories("${CMAKE_SOURCE_DIR}/core/include/c_api/")

# Initialize name for example binaries
set(EXAMPLE_BINS)

# Iterate over all example sources and call the build function
foreach(EXAMPLE_SOURCE ${TILEDB_EXAMPLE_SOURCES})
  # Get the binary name
  get_filename_component(EXAMPLE_STRIPPED ${EXAMPLE_SOURCE} NAME)
  STRING(REGEX REPLACE ".cc$" "" EXAMPLE_BIN ${EXAMPLE_STRIPPED})
  set(EXAMPLE_BINS ${EXAMPLE_BINS} ${EXAMPLE_BIN})

  # Build example executable
  build_TileDB_example(${EXAMPLE_BIN})
endforeach()

# Add custom target 'examples'
add_custom_target(examples DEPENDS tiledb_static)
add_dependencies(examples ${EXAMPLE_BINS})

# Run a subset of examples for Continuous Integration Testing
if(NOT TILEDB_DISABLE_TESTING)
  set(CI_TESTS ${CMAKE_SOURCE_DIR}/examples/run_examples.sh)
  add_test(NAME ci_tests COMMAND ${CI_TESTS})
  add_custom_target(ci_tests COMMAND ${CI_TESTS} DEPENDS examples)
  add_dependencies(tests ci_tests)
endif()

=== test/CMakeLists.txt ===
#
# test/CMakeLists.txt
#
#
# The MIT License
#
# Copyright (c) 2016 MIT and Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

# Include test header directories
file(GLOB TILEDB_TEST_INCLUDE_DIRS "include/*")
include_directories(${TILEDB_TEST_INCLUDE_DIRS})

# Include TileDB core header directories
file(GLOB TILEDB_CORE_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../core/include/*")
include_directories(${TILEDB_CORE_INCLUDE_DIRS})

# Get test source files
file(GLOB_RECURSE TILEDB_TEST_SOURCES "src/*/test*.cc")

# Add TILEDB_TEST_DIR macro
add_definitions(-DTILEDB_TEST_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

# Build one executable per test
foreach(TILEDB_TEST_SOURCE ${TILEDB_TEST_SOURCES})
  get_filename_component(FILENAME ${TILEDB_TEST_SOURCE} NAME)
  string(REGEX REPLACE ".cc$" "" TARGET ${FILENAME})
  
  add_executable(${TARGET} EXCLUDE_FROM_ALL ${TILEDB_TEST_SOURCE})
  target_link_libraries(${TARGET} tiledb_static ${TILEDB_LIB_DEPENDENCIES} -ldl)

  add_test(${TARGET} ${TARGET})
  set(ALL_CMDS ${ALL_CMDS} ${TARGET})
endforeach()

# Add custom target 'check'
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -V DEPENDS ${ALL_CMDS})

# Add check to all tests
add_dependencies(tests ${ALL_CMDS})

=== tests/requirements.txt ===
pytest
pylint
PyVCF
jsondiff

=== tools/CMakeLists.txt ===
include_directories("include")

# CMake/GCC doesn't add "-pie" by default for executables (CMake issue #14983)
if(NOT APPLE)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
endif()

if(NOT DISABLE_MPI)
  build_GenomicsDB_executable(create_genomicsdb_workspace)
  build_GenomicsDB_executable(gt_mpi_gather)
  build_GenomicsDB_executable(vcf2genomicsdb_init)
  build_GenomicsDB_executable(vcf2genomicsdb)
  build_GenomicsDB_executable(vcfdiff)
  build_GenomicsDB_executable(vcf_histogram)
  build_GenomicsDB_executable(consolidate_genomicsdb_array)

  add_test(NAME tools_tests COMMAND ${CMAKE_SOURCE_DIR}/tests/test_tools.sh ${CMAKE_SOURCE_DIR}/tests/inputs/vcfs ${CMAKE_INSTALL_PREFIX})
endif()

=== src/main/CMakeLists.txt ===
#
# CMakeLists.txt
#
# The MIT License
#
# Copyright (c) 2019-2020,2022 Omics Data Automation, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

set(GenomicsDB_library_sources 
    cpp/src/query_operations/variant_operations.cc
    cpp/src/query_operations/broad_combined_gvcf.cc
    cpp/src/query_operations/variant_operations_columnar.cc
    cpp/src/query_operations/broad_combined_gvcf_columnar.cc
    cpp/src/query_operations/gt_remapper_gvcf_columnar_iterator.cc
    cpp/src/genomicsdb/variant_cell.cc
    cpp/src/genomicsdb/variant_storage_manager.cc
    cpp/src/genomicsdb/variant_field_data.cc
    cpp/src/genomicsdb/variant_array_schema.cc
    cpp/src/genomicsdb/variant_field_handler.cc
    cpp/src/genomicsdb/variant.cc
    cpp/src/genomicsdb/query_variants.cc
    cpp/src/genomicsdb/genomicsdb_columnar_field.cc
    cpp/src/genomicsdb/genomicsdb_iterators.cc
    cpp/src/genomicsdb/genomicsdb_multid_vector_field.cc
    cpp/src/loader/tiledb_loader_text_file.cc
    cpp/src/loader/load_operators.cc
    cpp/src/loader/genomicsdb_importer.cc
    cpp/src/loader/tiledb_loader_file_base.cc
    cpp/src/loader/tiledb_loader.cc
    cpp/src/utils/memory_measure.cc
    cpp/src/utils/histogram.cc
    cpp/src/utils/vid_mapper_pb.cc
    cpp/src/utils/lut.cc
    cpp/src/utils/known_field_info.cc
    cpp/src/utils/vid_mapper.cc
    cpp/src/utils/vid_mapper_sql.cc
    cpp/src/utils/timer.cc
    cpp/src/utils/genomicsdb_logger.cc
    cpp/src/utils/alleles_combiner_gvcf_columnar_iterator.cc
    cpp/src/vcf/vcf_adapter.cc
    cpp/src/vcf/genomicsdb_bcf_generator.cc
    cpp/src/vcf/vcf2binary.cc
    cpp/src/vcf/hfile_genomicsdb.c
    cpp/src/vcf/htslib_fs_adapter.cc
    cpp/src/config/variant_query_config.cc
    cpp/src/config/genomicsdb_config_base.cc
    cpp/src/config/json_config.cc
    cpp/src/config/pb_config.cc
    cpp/src/api/annotation_service.cc
    cpp/src/api/genomicsdb.cc
    cpp/src/api/genomicsdb_field.cc
    cpp/src/api/genomicsdb_plink.cc
    )

include_directories(${PROTOBUF_GENERATED_CXX_HDRS_INCLUDE_DIRS})
set(GenomicsDB_library_sources
    ${GenomicsDB_library_sources}
    ${PROTOBUF_GENERATED_CXX_SRCS}
    )

if(PROTOBUF_REGENERATE)
    #Must be set here - see https://cmake.org/cmake/help/v3.3/command/set_source_files_properties.html
    if(BUILD_FOR_PYTHON)
      set_source_files_properties(${PROTOBUF_GENERATED_CXX_SRCS} ${PROTOBUF_GENERATED_CXX_HDRS} ${PROTOBUF_GENERATED_PYTHON_SRCS} PROPERTIES GENERATED True)
    else()
      set_source_files_properties(${PROTOBUF_GENERATED_CXX_SRCS} ${PROTOBUF_GENERATED_CXX_HDRS} PROPERTIES GENERATED True)
    endif()
endif()

if(BUILD_JAVA)
    set(GenomicsDB_library_sources ${GenomicsDB_library_sources}
        jni/src/genomicsdb_GenomicsDBUtils.cc
        jni/src/genomicsdb_GenomicsDBImporter.cc
        jni/src/genomicsdb_GenomicsDBQuery.cc
        jni/src/genomicsdb_GenomicsDBQueryStream.cc
        jni/src/genomicsdb_jni_init.cc
        )
endif()

#Compile sources with PIC
add_library(GenomicsDB_library_object_files OBJECT ${GenomicsDB_library_sources})
if(PROTOBUF_REGENERATE)
    add_dependencies(GenomicsDB_library_object_files PROTOBUF_GENERATED_CXX_TARGET)
endif()
set_property(TARGET GenomicsDB_library_object_files PROPERTY POSITION_INDEPENDENT_CODE ON)

#Create the shared and static libraries
add_library(genomicsdb STATIC $<TARGET_OBJECTS:GenomicsDB_library_object_files>)
#Link in other libraries
add_library(tiledbgenomicsdb SHARED $<TARGET_OBJECTS:GenomicsDB_library_object_files>)
if(TILEDB_SOURCE_DIR)
    target_link_libraries(tiledbgenomicsdb tiledb_static)
else()
    target_link_libraries(tiledbgenomicsdb ${TILEDB_LIBRARY})
endif()
if(HTSLIB_SOURCE_DIR)
    add_dependencies(tiledbgenomicsdb htslib)
endif()
target_link_libraries(tiledbgenomicsdb ${HTSLIB_LIBRARY} ${GENOMICSDB_EXTERNAL_DEPENDENCIES_LIBRARIES})
if(LIBRT_LIBRARY)
    target_link_libraries(tiledbgenomicsdb ${LIBRT_LIBRARY})
endif()

if(LIBCSV_FOUND)
    target_link_libraries(tiledbgenomicsdb ${LIBCSV_LIBRARY})
endif()
#if(BUILD_DISTRIBUTABLE_LIBRARY)
    #target_link_libraries(tiledbgenomicsdb ${OPENSSL_LIBRARIES})
#endif()

install(TARGETS genomicsdb tiledbgenomicsdb LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
install(FILES cpp/include/api/genomicsdb.h  cpp/include/api/genomicsdb_exception.h DESTINATION include)
if(BUILD_FOR_PYTHON)
  install(FILES ${PROTOBUF_GENERATED_PYTHON_SRCS} DESTINATION genomicsdb/protobuf/python)
endif()

=== src/resources/CMakeLists.txt ===
#
# CMakeLists.txt
#
# The MIT License
#
# Copyright (c) 2021-2022 Omics Data Automation, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

set(PROTOBUF_PROTO_FILES
  genomicsdb_coordinates.proto
  genomicsdb_callsets_mapping.proto
  genomicsdb_export_config.proto
  genomicsdb_import_config.proto
  genomicsdb_vid_mapping.proto
  )

if(PROTOBUF_REGENERATE)
  set(PROTO_SRC_DIR ${CMAKE_CURRENT_BINARY_DIR})
else()
  set(PROTO_SRC_DIR ${CMAKE_SOURCE_DIR}/src/main/protobuf-generated/cpp/src)
endif()

foreach(PROTO_FILE ${PROTOBUF_PROTO_FILES})
  get_filename_component(CURR_FILENAME ${PROTO_FILE} NAME_WE)
  list(APPEND PROTO_GENERATED_CXX_SRCS ${PROTO_SRC_DIR}/${CURR_FILENAME}.pb.cc)
  list(APPEND PROTO_GENERATED_CXX_HDRS ${PROTO_SRC_DIR}/${CURR_FILENAME}.pb.h)
  if(BUILD_FOR_PYTHON)
    list(APPEND PROTO_GENERATED_PYTHON_SRCS ${PROTO_SRC_DIR}/python/${CURR_FILENAME}_pb2.py)
  endif()
endforeach()

if(PROTOBUF_REGENERATE)
  set(PROTOBUF_GENERATED_CXX_HDRS_INCLUDE_DIRS ${CMAKE_CURRENT_BINARY_DIR})
  add_custom_command(OUTPUT ${PROTO_GENERATED_CXX_SRCS} ${PROTO_GENERATED_CXX_HDRS}
    COMMAND ${PROTOBUF_PROTOC_EXECUTABLE} --cpp_out=${CMAKE_CURRENT_BINARY_DIR} ${PROTOBUF_PROTO_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    BYPRODUCTS ${PROTO_GENERATED_CXX_SRCS} ${PROTO_GENERATED_CXX_HDRS}
    COMMENT "Generating source/header files from .proto files"
    DEPENDS protobuf_ep ${PROTOBUF_PROTO_FILES})
  if(BUILD_FOR_PYTHON)
    add_custom_command(OUTPUT ${PROTO_GENERATED_PYTHON_SRCS}
      COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/python &&
	      ${PROTOBUF_PROTOC_EXECUTABLE} --python_out=${CMAKE_CURRENT_BINARY_DIR}/python ${PROTOBUF_PROTO_FILES}
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      BYPRODUCTS ${PROTO_GENERATED_PYTHON_SRCS}
      COMMENT "Generating GenomicsDB protobuf python bindings"
      DEPENDS protobuf_ep  ${PROTOBUF_PROTO_FILES})
  endif()
  add_custom_target(PROTOBUF_GENERATED_CXX_TARGET DEPENDS
    ${PROTO_GENERATED_CXX_SRCS} ${PROTO_GENERATED_CXX_HDRS} ${PROTO_GENERATED_PYTHON_SRCS})
  set(PROTOBUF_GENERATED_JAVA_SRCS
    ${GENOMICSDB_MAVEN_BUILD_DIR}/protobuf/org/genomicsdb/GenomicsDBColumn.java
    ${GENOMICSDB_MAVEN_BUILD_DIR}/protobuf/org/genomicsdb/GenomicsDBCallsetsMapProto.java
    ${GENOMICSDB_MAVEN_BUILD_DIR}/protobuf/org/genomicsdb/GenomicsDBExportConfiguration.java
    ${GENOMICSDB_MAVEN_BUILD_DIR}/protobuf/org/genomicsdb/GenomicsDBImportConfiguration.java
    ${GENOMICSDB_MAVEN_BUILD_DIR}/protobuf/org/genomicsdb/GenomicsDBVidMapProto.java
    )
else()
  set(PROTOBUF_GENERATED_CXX_HDRS_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/src/main/protobuf-generated/cpp/include")
  set(PROTOBUF_GENERATED_JAVA_SRCS
    src/main/protobuf-generated/java/org/genomicsdb/GenomicsDBCallsetsMapProto.java
    src/main/protobuf-generated/java/org/genomicsdb/GenomicsDBExportConfiguration.java
    src/main/protobuf-generated/java/org/genomicsdb/GenomicsDBImportConfiguration.java
    src/main/protobuf-generated/java/org/genomicsdb/GenomicsDBVidMapProto.java
    )
endif()

set(PROTOBUF_GENERATED_CXX_SRCS ${PROTO_GENERATED_CXX_SRCS} CACHE INTERNAL "Protocol buffers generated C++ sources")
set(PROTOBUF_GENERATED_CXX_HDRS ${PROTO_GENERATED_CXX_HDRS} CACHE INTERNAL "Protocol buffers generated C++ headers")
set(PROTOBUF_GENERATED_CXX_HDRS_INCLUDE_DIRS ${PROTOBUF_GENERATED_CXX_HDRS_INCLUDE_DIRS} CACHE INTERNAL "Directory containing Protocol buffers generated C++ headers")
set(PROTOBUF_GENERATED_PYTHON_SRCS ${PROTO_GENERATED_PYTHON_SRCS} CACHE INTERNAL "Generated Python protobuf sources")
set(PROTOBUF_GENERATED_JAVA_SRCS ${PROTOBUF_GENERATED_JAVA_SRCS} CACHE INTERNAL "Protocol buffers generated Java sources")

=== src/test/cpp/CMakeLists.txt ===
#
# src/test/cpp/CMakeLists.txt
#
#
# The MIT License
#
# Copyright (c) 2019 Omics Data Automation, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

include_directories(Catch INTERFACE Catch2/single_include)
include_directories(${PROTOBUF_GENERATED_CXX_HDRS_INCLUDE_DIRS})

set(CPP_TEST_SOURCES
  src/ctest_main.cc
  src/test_config.cc
  src/test_non_diploid_mapper.cc
  src/test_multid_vector.cc
  src/test_pb.cc
  src/test_logger.cc
  src/test_columnar_gvcf_iterator.cc
  src/test_htslib_plugin.cc
  src/test_alleles_combiner.cc
  src/test_gt_remapper.cc
  src/test_bgen.cc
  )

if(LIBDBI_FOUND)
  set(CPP_TEST_SOURCES
    ${CPP_TEST_SOURCES}
    src/test_mapping_data_loader.cc)
endif()

function(target_link_libraries_for_GenomicsDB_tests target)
   build_GenomicsDB_links(${target})
   # Need to explicitly add in pthread/dl libs for static linkage
   if(BUILD_DISTRIBUTABLE_LIBRARY)
     target_link_libraries(${target} pthread ${CMAKE_DL_LIBS})
   endif()
endfunction()

add_executable(ctests ${CPP_TEST_SOURCES})
target_link_libraries_for_GenomicsDB_tests(ctests)

#test_bgen has to be fixed, until then...
if(BUILD_DISTRIBUTABLE_LIBRARY OR BUILD_FOR_PYTHON)
  set(INCLUDE_TEST_BGEN 0)
else()
  set(INCLUDE_TEST_BGEN 1)
endif()
target_compile_definitions(ctests PRIVATE -DINCLUDE_TEST_BGEN=${INCLUDE_TEST_BGEN} -DGENOMICSDB_CTESTS_DIR="${CMAKE_CURRENT_BINARY_DIR}/inputs/" -DGENOMICSDB_TESTS_SRC_DIR="${CMAKE_SOURCE_DIR}/tests/")
add_test(ctests ctests -d yes)

add_executable(api_tests
  src/ctest_main.cc
  src/test_genomicsdb_api.cc)
target_link_libraries_for_GenomicsDB_tests(api_tests)
target_compile_definitions(api_tests PRIVATE -DGENOMICSDB_CTESTS_DIR="${CMAKE_CURRENT_BINARY_DIR}/inputs/")
add_test(api_tests api_tests -d yes)

add_custom_command(TARGET api_tests
  COMMAND ${CMAKE_COMMAND} -E tar xzf ${CMAKE_CURRENT_SOURCE_DIR}/../inputs/test.tgz
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../inputs/test.tgz)

add_custom_target(all_ctests COMMAND ${CMAKE_CTEST_COMMAND} -V DEPENDS ctests api_tests)

=== debian/changelog ===
genomicsdb (1.4.4-3) unstable; urgency=medium

  * Removing B-D on libtiledb-dev (Closes: #1033456)
  * Raising Standards version to 4.6.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Sun, 26 Mar 2023 15:28:08 +0200

genomicsdb (1.4.4-2) unstable; urgency=medium

  * Reorganizing debian/rules by honouring -arch and -indep overrides
  * Filling in B-D-Arch and B-D-Indep in debian/control
  * Adding a Lintian override for patches not forwarded

 -- Pierre Gruet <pgt@debian.org>  Mon, 12 Sep 2022 17:30:03 +0200

genomicsdb (1.4.4-1) unstable; urgency=medium

  * New upstream version 1.4.4
  * Refreshing patches
  * Adding patches to correct failures arising with new upstream version
  * Adding another missing dependency in the pom
  * Adding missing build-dependencies
  * Reworking d/copyright: changing years and removing deleted files
  * Forwarding patches

 -- Pierre Gruet <pgt@debian.org>  Sun, 11 Sep 2022 23:19:41 +0200

genomicsdb (1.4.3-1) unstable; urgency=medium

  * Initial release (Closes: #1016046)

 -- Pierre Gruet <pgt@debian.org>  Thu, 28 Jul 2022 17:35:09 +0200

=== debian/control ===
Source: genomicsdb
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               catch2,
               cmake,
               default-jdk,
               javahelper,
               libbz2-dev,
               libcurlpp-dev,
               libfmt-dev,
               libmuparserx-dev,
               libopenmpi-dev,
               libprotobuf-dev,
               libspdlog-dev,
               libssl-dev,
               liblzma-dev,
               maven-debian-helper,
               protobuf-compiler,
               rapidjson-dev,
               testng <!nocheck>,
               uuid-dev
Build-Depends-Arch: chrpath
Build-Depends-Indep: libbuild-helper-maven-plugin-java,
                     libcommons-io-java,
                     libcommons-lang3-java,
                     libgetopt-java,
                     libguava-java,
                     libhtsjdk-java,
                     libjson-simple-java,
                     liblog4j2-java,
                     libmaven-antrun-plugin-java,
                     libprotobuf-java,
                     libprotobuf-java-format-java,
                     libsurefire-java
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/genomicsdb
Vcs-Git: https://salsa.debian.org/med-team/genomicsdb.git
Homepage: https://www.genomicsdb.org/
Rules-Requires-Root: no

Package: libgenomicsdb-java
Section: java
Architecture: all
Depends: ${maven:Depends},
         ${java:Depends},
         libgenomicsdb-jni (>= ${source:Version}),
         libgenomicsdb-jni (<< ${source:Version}.1~),
         ${misc:Depends}
Description: sparse array storage library for genomics (Java library)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the Java library.

Package: libgenomicsdb-jni
Section: java
Architecture: any
Depends: ${shlibs:Depends},
         libgenomicsdb0 (= ${binary:Version}),
         ${misc:Depends}
Description: sparse array storage library for genomics (Java native bindings)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the Java native bindings.

Package: genomicsdb-tools
Architecture: any
Depends: ${shlibs:Depends},
         libgenomicsdb0 (= ${binary:Version}),
         ${misc:Depends}
Description: sparse array storage library for genomics (tools)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains some tools to be run as executable files.

Package: libgenomicsdb0
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openmpi-bin
Description: sparse array storage library for genomics (shared libraries)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the shared library.

Package: libgenomicsdb-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         libgenomicsdb0 (= ${binary:Version}),
         ${misc:Depends}
Description: sparse array storage library for genomics (development files)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the development files and the static library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/pkg-info.mk

VERSION = $(DEB_VERSION_UPSTREAM)
SOVERSION = 0

export JAVA_HOME = /usr/lib/jvm/default-java

%:
	dh $@ --buildsystem=cmake --with javahelper

override_dh_auto_clean:
	# Removing the files we provided manually for the build of the component
	if [ -e genomicsdb-htslib/CMakeLists.txt ]; then rm genomicsdb-htslib/CMakeLists.txt; fi
	if [ -e genomicsdb-htslib/config.h ]; then rm genomicsdb-htslib/config.h; fi
	if [ -e genomicsdb-htslib/version.h ]; then rm genomicsdb-htslib/version.h; fi
	dh_auto_clean
	dh_auto_clean --buildsystem=maven
	# Removing the debian/maven.properties file we setup during configure step.
	if [ -e debian/maven.properties ]; then rm debian/maven.properties; fi
	# Removing the patched pom.xml file.
	if [ -e pom.xml.old ]; then mv pom.xml.old pom.xml; fi

override_dh_auto_configure-arch:
	# Preparing the build of the htslib component.
	cp debian/htslibComponentFiles/* genomicsdb-htslib/
	echo '#define HTS_VERSION_TEXT "$(HTS_COMPONENT_VERSION)"' > genomicsdb-htslib/version.h
	# Configuring the C++ part using CMake.
	dh_auto_configure -- \
	        -DBUILD_JAVA:BOOL=False \
	        -DCMAKE_INSTALL_PREFIX:PATH=/usr \
	        -DJAVA_HOME:PATH=$(JAVA_HOME) \
	        -DPROTOBUF_ROOT_DIR:PATH=/usr \
	        -DCMAKE_LIBRARY_ARCHITECTURE:STRING=$(DEB_HOST_MULTIARCH) \
	        -DVERSION=$(VERSION) \
	        -DSOVERSION=$(SOVERSION)

override_dh_auto_configure-indep: override_dh_auto_configure-arch
	# Configuring the Java part using Maven.
	# First we put the arch triplet in d/maven.properties for the tests.
	echo "build.triplet=$(DEB_HOST_MULTIARCH)" > debian/maven.properties
	mv pom.xml pom.xml.old
	sed 's/\$${genomicsdb\.version}/$(DEB_VERSION_UPSTREAM)/; s,\$${protoc\.filepath},/usr/bin/protoc,' pom.xml.old > pom.xml
	dh_auto_configure --buildsystem=maven

# Trick to be able to build the arch-dependent binaries before the indep- tests.
override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	# Building the Java part with Maven.
	dh_auto_build --buildsystem=maven

# We need the arch-dependent binaries to run the Java tests afterwards.
override_dh_auto_test-indep: override_dh_auto_build-arch
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Testing the Java part. We extend LD_LIBRARY_PATH because some test code is
	# run without surefire.
	LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:obj-$(DEB_HOST_MULTIARCH)/src/main" dh_auto_test --buildsystem=maven
endif

override_dh_auto_install-indep:
	# Installing the Java part.
	dh_auto_install --buildsystem=maven

execute_after_dh_install-arch:
	# Setting the runpath of the jni library to only contain the path to the private libs.
	chrpath -r "/usr/lib/$(DEB_HOST_MULTIARCH)/genomicsdb" $(CURDIR)/debian/libgenomicsdb-jni/usr/lib/jni/libgenomicsdbjni.so

=== debian/tests/control ===
Tests: runJavaExample
Depends: default-jdk, libgenomicsdb-java
Restrictions: allow-stderr

Tests: runTestTools
Depends: genomicsdb-tools
